Tidy up CLI commands, add `app list`
continuous-integration/drone/push Build is failing Details

This commit is contained in:
3wc 2020-10-27 21:38:20 +02:00
parent bec3272a41
commit c5785089d6
1 changed files with 201 additions and 148 deletions

349
abra
View File

@ -3,21 +3,24 @@
GIT_URL="https://git.autonomic.zone/coop-cloud/"
ABRA_DIR="$HOME/.abra"
###### Global help
#######################################
# Global help
#######################################
DOC="
The cooperative cloud utility belt 🎩🐇
Usage:
abra [options] new [--server=<server> --domain=<domain>] <app>
abra [options] <domain> deploy
abra [options] <domain> logs [<service>]
abra [options] <domain> multilogs
abra [options] <domain> cp <src> <dst>
abra [options] <domain> run [--user=<user>] <service> <args>...
abra [options] <domain> run <service> <args>...
abra [options] <domain> secret generate <secret> <version> [<cmd>]
abra [options] <domain> secret insert <secret> <version> <data>
abra [options] app new [--server=<server> --domain=<domain>] <app>
abra [options] app (list|ls)
abra [options] app <domain> deploy
abra [options] app <domain> logs [<service>]
abra [options] app <domain> multilogs
abra [options] app <domain> cp <src> <dst>
abra [options] app <domain> run [--user=<user>] <service> <args>...
abra [options] app <domain> run <service> <args>...
abra [options] app <domain> secret generate <secret> <version> [<cmd>]
abra [options] app <domain> secret insert <secret> <version> <data>
abra [options] server add <host> [<user>] [<port>]
abra [options] server rm <host>
abra [options] server use <host>
@ -27,7 +30,6 @@ Usage:
abra [options] <command> <args>...
Options:
-c, --config=<path> Stack configuration to use
-e, --env=<path> Environment variables to load
-h, --help Show this message and exit
-s, --stack=<path> Name of the target stack
@ -135,58 +137,59 @@ eval "var_$1+=($value)"; else eval "var_$1=$value"; fi; return 0; fi; done
return 1; }; stdout() { printf -- "cat <<'EOM'\n%s\nEOM\n" "$1"; }; stderr() {
printf -- "cat <<'EOM' >&2\n%s\nEOM\n" "$1"; }; error() {
[[ -n $1 ]] && stderr "$1"; stderr "$usage"; _return 1; }; _return() {
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1080}
usage=${DOC:40:722}; digest=14148; shorts=(-h -c -s -e -v '' '' '')
longs=(--help --config --stack --env --version --server --domain --user)
argcounts=(0 1 1 1 0 1 1 1); node_0(){ switch __help 0; }; node_1(){
value __config 1; }; node_2(){ value __stack 2; }; node_3(){ value __env 3; }
node_4(){ switch __version 4; }; node_5(){ value __server 5; }; node_6(){
value __domain 6; }; node_7(){ value __user 7; }; node_8(){ value _app_ a; }
node_9(){ value _domain_ a; }; node_10(){ value _service_ a; }; node_11(){
value _src_ a; }; node_12(){ value _dst_ a; }; node_13(){ value _args_ a true; }
node_14(){ value _secret_ a; }; node_15(){ value _version_ a; }; node_16(){
value _cmd_ a; }; node_17(){ value _data_ a; }; node_18(){ value _host_ a; }
node_19(){ value _user_ a; }; node_20(){ value _port_ a; }; node_21(){
value _command_ a; }; node_22(){ _command new; }; node_23(){ _command deploy; }
node_24(){ _command logs; }; node_25(){ _command multilogs; }; node_26(){
_command cp; }; node_27(){ _command run; }; node_28(){ _command secret; }
node_29(){ _command generate; }; node_30(){ _command insert; }; node_31(){
_command server; }; node_32(){ _command add; }; node_33(){ _command rm; }
node_34(){ _command use; }; node_35(){ _command init; }; node_36(){ _command ls
}; node_37(){ _command upgrade; }; node_38(){ optional 0 1 2 3 4; }; node_39(){
optional 38; }; node_40(){ optional 5 6; }; node_41(){ required 39 22 40 8; }
node_42(){ required 39 9 23; }; node_43(){ optional 10; }; node_44(){
required 39 9 24 43; }; node_45(){ required 39 9 25; }; node_46(){
required 39 9 26 11 12; }; node_47(){ optional 7; }; node_48(){ oneormore 13; }
node_49(){ required 39 9 27 47 10 48; }; node_50(){ required 39 9 27 10 48; }
node_51(){ optional 16; }; node_52(){ required 39 9 28 29 14 15 51; }
node_53(){ required 39 9 28 30 14 15 17; }; node_54(){ optional 19; }
node_55(){ optional 20; }; node_56(){ required 39 31 32 18 54 55; }; node_57(){
required 39 31 33 18; }; node_58(){ required 39 31 34 18; }; node_59(){
required 39 31 35 18; }; node_60(){ required 39 31 36; }; node_61(){
required 39 37; }; node_62(){ required 39 21 48; }; node_63(){
either 41 42 44 45 46 49 50 52 53 56 57 58 59 60 61 62; }; node_64(){
required 63; }; cat <<<' docopt_exit() { [[ -n $1 ]] && printf "%s\n" "$1" >&2
printf "%s\n" "${DOC:40:722}" >&2; exit 1; }'; unset var___help var___config \
var___stack var___env var___version var___server var___domain var___user \
var__app_ var__domain_ var__service_ var__src_ var__dst_ var__args_ \
var__secret_ var__version_ var__cmd_ var__data_ var__host_ var__user_ \
var__port_ var__command_ var_new var_deploy var_logs var_multilogs var_cp \
var_run var_secret var_generate var_insert var_server var_add var_rm var_use \
var_init var_ls var_upgrade; parse 64 "$@"; local prefix=${DOCOPT_PREFIX:-''}
unset "${prefix}__help" "${prefix}__config" "${prefix}__stack" \
"${prefix}__env" "${prefix}__version" "${prefix}__server" "${prefix}__domain" \
"${prefix}__user" "${prefix}_app_" "${prefix}_domain_" "${prefix}_service_" \
"${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" \
"${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}_command_" "${prefix}new" \
"${prefix}deploy" "${prefix}logs" "${prefix}multilogs" "${prefix}cp" \
"${prefix}run" "${prefix}secret" "${prefix}generate" "${prefix}insert" \
"${prefix}server" "${prefix}add" "${prefix}rm" "${prefix}use" "${prefix}init" \
"${prefix}ls" "${prefix}upgrade"; eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__config=${var___config:-}'
eval "${prefix}"'__stack=${var___stack:-}'
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1097}
usage=${DOC:40:789}; digest=9b786; shorts=(-e -h -s -v '' '' '')
longs=(--env --help --stack --version --server --domain --user)
argcounts=(1 0 1 0 1 1 1); node_0(){ value __env 0; }; node_1(){ switch __help 1
}; node_2(){ value __stack 2; }; node_3(){ switch __version 3; }; node_4(){
value __server 4; }; node_5(){ value __domain 5; }; node_6(){ value __user 6; }
node_7(){ value _app_ a; }; node_8(){ value _domain_ a; }; node_9(){
value _service_ a; }; node_10(){ value _src_ a; }; node_11(){ value _dst_ a; }
node_12(){ value _args_ a true; }; node_13(){ value _secret_ a; }; node_14(){
value _version_ a; }; node_15(){ value _cmd_ a; }; node_16(){ value _data_ a; }
node_17(){ value _host_ a; }; node_18(){ value _user_ a; }; node_19(){
value _port_ a; }; node_20(){ value _command_ a; }; node_21(){ _command app; }
node_22(){ _command new; }; node_23(){ _command list; }; node_24(){ _command ls
}; node_25(){ _command deploy; }; node_26(){ _command logs; }; node_27(){
_command multilogs; }; node_28(){ _command cp; }; node_29(){ _command run; }
node_30(){ _command secret; }; node_31(){ _command generate; }; node_32(){
_command insert; }; node_33(){ _command server; }; node_34(){ _command add; }
node_35(){ _command rm; }; node_36(){ _command use; }; node_37(){ _command init
}; node_38(){ _command upgrade; }; node_39(){ optional 0 1 2 3; }; node_40(){
optional 39; }; node_41(){ optional 4 5; }; node_42(){ required 40 21 22 41 7; }
node_43(){ either 23 24; }; node_44(){ required 43; }; node_45(){
required 40 21 44; }; node_46(){ required 40 21 8 25; }; node_47(){ optional 9
}; node_48(){ required 40 21 8 26 47; }; node_49(){ required 40 21 8 27; }
node_50(){ required 40 21 8 28 10 11; }; node_51(){ optional 6; }; node_52(){
oneormore 12; }; node_53(){ required 40 21 8 29 51 9 52; }; node_54(){
required 40 21 8 29 9 52; }; node_55(){ optional 15; }; node_56(){
required 40 21 8 30 31 13 14 55; }; node_57(){ required 40 21 8 30 32 13 14 16
}; node_58(){ optional 18; }; node_59(){ optional 19; }; node_60(){
required 40 33 34 17 58 59; }; node_61(){ required 40 33 35 17; }; node_62(){
required 40 33 36 17; }; node_63(){ required 40 33 37 17; }; node_64(){
required 40 33 24; }; node_65(){ required 40 38; }; node_66(){ required 40 20 52
}; node_67(){ either 42 45 46 48 49 50 53 54 56 57 60 61 62 63 64 65 66; }
node_68(){ required 67; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:789}" >&2; exit 1
}'; unset var___env var___help var___stack var___version var___server \
var___domain var___user var__app_ var__domain_ var__service_ var__src_ \
var__dst_ var__args_ var__secret_ var__version_ var__cmd_ var__data_ \
var__host_ var__user_ var__port_ var__command_ var_app var_new var_list var_ls \
var_deploy var_logs var_multilogs var_cp var_run var_secret var_generate \
var_insert var_server var_add var_rm var_use var_init var_upgrade; parse 68 "$@"
local prefix=${DOCOPT_PREFIX:-''}; unset "${prefix}__env" "${prefix}__help" \
"${prefix}__stack" "${prefix}__version" "${prefix}__server" \
"${prefix}__domain" "${prefix}__user" "${prefix}_app_" "${prefix}_domain_" \
"${prefix}_service_" "${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" \
"${prefix}_secret_" "${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" \
"${prefix}_host_" "${prefix}_user_" "${prefix}_port_" "${prefix}_command_" \
"${prefix}app" "${prefix}new" "${prefix}list" "${prefix}ls" "${prefix}deploy" \
"${prefix}logs" "${prefix}multilogs" "${prefix}cp" "${prefix}run" \
"${prefix}secret" "${prefix}generate" "${prefix}insert" "${prefix}server" \
"${prefix}add" "${prefix}rm" "${prefix}use" "${prefix}init" "${prefix}upgrade"
eval "${prefix}"'__env=${var___env:-}'
eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__stack=${var___stack:-}'
eval "${prefix}"'__version=${var___version:-false}'
eval "${prefix}"'__server=${var___server:-}'
eval "${prefix}"'__domain=${var___domain:-}'
@ -203,7 +206,8 @@ eval "${prefix}"'_host_=${var__host_:-}'
eval "${prefix}"'_user_=${var__user_:-}'
eval "${prefix}"'_port_=${var__port_:-}'
eval "${prefix}"'_command_=${var__command_:-}'
eval "${prefix}"'new=${var_new:-false}'
eval "${prefix}"'app=${var_app:-false}'; eval "${prefix}"'new=${var_new:-false}'
eval "${prefix}"'list=${var_list:-false}'; eval "${prefix}"'ls=${var_ls:-false}'
eval "${prefix}"'deploy=${var_deploy:-false}'
eval "${prefix}"'logs=${var_logs:-false}'
eval "${prefix}"'multilogs=${var_multilogs:-false}'
@ -214,23 +218,27 @@ eval "${prefix}"'insert=${var_insert:-false}'
eval "${prefix}"'server=${var_server:-false}'
eval "${prefix}"'add=${var_add:-false}'; eval "${prefix}"'rm=${var_rm:-false}'
eval "${prefix}"'use=${var_use:-false}'
eval "${prefix}"'init=${var_init:-false}'; eval "${prefix}"'ls=${var_ls:-false}'
eval "${prefix}"'init=${var_init:-false}'
eval "${prefix}"'upgrade=${var_upgrade:-false}'; local docopt_i=1
[[ $BASH_VERSION =~ ^4.3 ]] && docopt_i=2; for ((;docopt_i>0;docopt_i--)); do
declare -p "${prefix}__help" "${prefix}__config" "${prefix}__stack" \
"${prefix}__env" "${prefix}__version" "${prefix}__server" "${prefix}__domain" \
"${prefix}__user" "${prefix}_app_" "${prefix}_domain_" "${prefix}_service_" \
"${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" \
"${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}_command_" "${prefix}new" \
"${prefix}deploy" "${prefix}logs" "${prefix}multilogs" "${prefix}cp" \
"${prefix}run" "${prefix}secret" "${prefix}generate" "${prefix}insert" \
"${prefix}server" "${prefix}add" "${prefix}rm" "${prefix}use" "${prefix}init" \
"${prefix}ls" "${prefix}upgrade"; done; }
declare -p "${prefix}__env" "${prefix}__help" "${prefix}__stack" \
"${prefix}__version" "${prefix}__server" "${prefix}__domain" "${prefix}__user" \
"${prefix}_app_" "${prefix}_domain_" "${prefix}_service_" "${prefix}_src_" \
"${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" "${prefix}_version_" \
"${prefix}_cmd_" "${prefix}_data_" "${prefix}_host_" "${prefix}_user_" \
"${prefix}_port_" "${prefix}_command_" "${prefix}app" "${prefix}new" \
"${prefix}list" "${prefix}ls" "${prefix}deploy" "${prefix}logs" \
"${prefix}multilogs" "${prefix}cp" "${prefix}run" "${prefix}secret" \
"${prefix}generate" "${prefix}insert" "${prefix}server" "${prefix}add" \
"${prefix}rm" "${prefix}use" "${prefix}init" "${prefix}upgrade"; done; }
# docopt parser above, complete command for generating this parser is `docopt.sh abra`
PROGRAM_NAME=$(basename "$0")
#######################################
# Helpers
#######################################
###### Utility functions
error() {
@ -295,13 +303,12 @@ load_custom_commands() {
fi
if [ -f "$ABRA_STACK_DIR/abra-commands.sh" ]; then
# shellcheck disable=SC1091
# shellcheck disable=SC1090
source "$ABRA_STACK_DIR/abra-commands.sh"
fi
}
load_instance() {
# FIXME 3wc: try and support old behaviour of just specifying -a STACK
DOMAIN="$abra__domain_"
ENV_FILE=$(find ~/.abra -name "$DOMAIN.env")
if [ "$(echo "$ENV_FILE" | wc -l)" -gt 1 ]; then
@ -333,77 +340,46 @@ load_context() {
fi
}
###### Subcommand `secret`
#######################################
# abra app ..
#######################################
sub_secret_insert() {
load_instance
load_instance_env
SECRET="$abra__secret_"
VERSION="$abra__version_"
PW="$abra__data_"
if [ -z "$SECRET" ] || [ -z "$VERSION" ] || [ -z "$PW" ]; then
error "Required arguments missing"
fi
echo "$PW" | docker secret create "${STACK_NAME}_${SECRET}_${VERSION}" - > /dev/null
if type pass > /dev/null 2>&1; then
echo "$PW" | pass insert "hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}" -m > /dev/null
success "pass: hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}"
fi
###### .. app (list|ls)
sub_app_ls (){
sub_app_list
}
sub_secret_generate(){
load_instance
load_instance_env
sub_app_list (){
shopt -s nullglob dotglob
ENV_FILES=(~/.abra/servers/*/*.env)
shopt -u nullglob dotglob
SECRET="$abra__secret_"
VERSION="$abra__version_"
PWGEN=${abra__cmd_:-pwqgen}
printf "%s lovely apps:\n\n" "${#ENV_FILES[@]}"
for i in "${!ENV_FILES[@]}"; do
local PARTS
if [ -z "$SECRET" ] || [ -z "$VERSION" ]; then
error "Required arguments missing"
fi
# Do this inside the loop to include in pipe to `column`
if [ "$i" == 0 ]; then
printf " DOMAIN\tAPP\tSERVER\n --\t--\t--\n"
fi
PW=$($PWGEN)
ENV_FILE="${ENV_FILES[$i]}"
success "Password: $PW"
IFS='/' read -r -a PARTS <<< "$ENV_FILE"
# FIXME 3wc: this is a little janky, might be better to make a
# util_secret_insert function which this and sub_secret_insert can call
abra__data_="$PW"
sub_secret_insert
FILE="${PARTS[-1]}"
SERVER="${PARTS[-2]}"
DOMAIN="${FILE%.env}"
# shellcheck disable=SC1090
APP="$(source "$ENV_FILE" && echo "$APP")"
printf " %s\t%s\t%s\n" "$DOMAIN" "$APP" "$SERVER"
done | column -s' ' -t
# Align table `-t` based on tab characters -s`^V<Tab>`
}
###### Subcommand `run`
sub_run(){
load_instance
if [ -n "$abra___user" ]; then
RUN_USER="-u $abra___user"
fi
CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
| grep "${STACK_NAME}_${abra__app_}" | head -n1 | cut -d',' -f1)
if [ -z "$CONTAINER" ]; then
error "Can't find a container for ${STACK_NAME}_${abra__app_}"
exit
fi
# shellcheck disable=SC2086
docker exec $RUN_USER -it "$CONTAINER" "$@"
return
}
###### Subcommand `new`
sub_new (){
###### .. app new [--domain=<domain> --server=<server>]
sub_app_new (){
require_abra_dir
APP=$abra__app_
@ -464,7 +440,8 @@ sub_new (){
echo " abra deploy $DOMAIN$(tput sgr0)"
}
sub_deploy (){
###### .. app <domain> deploy
sub_app_deploy (){
load_instance
load_instance_env
@ -508,10 +485,77 @@ sub_deploy (){
)
}
###### Subcommand `logs`
###### .. app <domain> secret insert
sub_app_secret_insert() {
load_instance
load_instance_env
# Inspired by https://github.com/moby/moby/issues/31458#issuecomment-475411564
sub_multilogs() {
SECRET="$abra__secret_"
VERSION="$abra__version_"
PW="$abra__data_"
if [ -z "$SECRET" ] || [ -z "$VERSION" ] || [ -z "$PW" ]; then
error "Required arguments missing"
fi
echo "$PW" | docker secret create "${STACK_NAME}_${SECRET}_${VERSION}" - > /dev/null
if type pass > /dev/null 2>&1; then
echo "$PW" | pass insert "hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}" -m > /dev/null
success "pass: hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}"
fi
}
###### .. app <domain> secret generate
sub_app_secret_generate(){
load_instance
load_instance_env
SECRET="$abra__secret_"
VERSION="$abra__version_"
PWGEN=${abra__cmd_:-pwqgen}
if [ -z "$SECRET" ] || [ -z "$VERSION" ]; then
error "Required arguments missing"
fi
PW=$($PWGEN)
success "Password: $PW"
# FIXME 3wc: this is a little janky, might be better to make a
# util_secret_insert function which this and sub_secret_insert can call
abra__data_="$PW"
sub_app_secret_insert
}
###### .. app <domain> run <args>...
sub_app_run(){
load_instance
if [ -n "$abra___user" ]; then
RUN_USER="-u $abra___user"
fi
CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
| grep "${STACK_NAME}_${abra__app_}" | head -n1 | cut -d',' -f1)
if [ -z "$CONTAINER" ]; then
error "Can't find a container for ${STACK_NAME}_${abra__app_}"
exit
fi
# shellcheck disable=SC2086
docker exec $RUN_USER -it "$CONTAINER" "$@"
return
}
###### .. app <domain> multilogs
sub_app_multilogs() {
# Inspired by https://github.com/moby/moby/issues/31458#issuecomment-475411564
require_multitail
load_instance
@ -530,7 +574,8 @@ sub_multilogs() {
bash -c "${COMMAND}"
}
sub_logs (){
###### .. app <domain> logs <service> <args>...
sub_app_logs (){
load_instance
load_instance_env
@ -538,7 +583,7 @@ sub_logs (){
if [ -z "$SERVICE" ]; then
warning "No \$SERVICE provided, running multilogs"
sub_multilogs
sub_app_multilogs
fi
shift
@ -559,9 +604,8 @@ sub_logs (){
docker service logs "${STACK_NAME}_${SERVICE}" $LOGS_ARGS
}
###### Subcommand `cp`
sub_cp() {
###### .. app <domain> cp <src> <dst>
sub_app_cp() {
require_stack
SOURCE="${abra__src_}"
@ -591,8 +635,11 @@ sub_cp() {
docker cp ${CP_ARGS}
}
###### Subcommand `server`
#######################################
# abra server ..
#######################################
###### .. server init <host>
sub_server_init() {
export DOCKER_CONTEXT="${abra__host_}"
@ -633,6 +680,10 @@ sub_server_ls() {
docker context ls
}
#######################################
# Misc commands
#######################################
###### Subcommand `upgrade`
sub_upgrade() {
@ -651,12 +702,14 @@ sub_volume() {
docker volume $@
}
###### Main
#######################################
# Main
#######################################
abra() {
# TODO (3wc): we either need to do this, or add 'shellcheck disable' all over
# the place to handle the dynamically-defined vars
declare abra___stack abra___env abra___config abra__command_ abra__args_ \
declare abra___stack abra___env abra__command_ abra__args_ \
abra__secret_ abra__version_ abra__data_ abra___user abra__host_ \
abra__app_ abra__port_ abra__user_ abra__service_ abra__src_ abra__dst_ \
abra__domain_ abra___server abra___domain